Subject: Re: Doubt regarding ARP cache updation

From: basila <[email-masked]>
Date: Sat, 17 Jan 98 08:24:00 PST

Peter,

>> In the above configuration,
>>
>> Virtual router VRID 1 will send gratuitous ARP for IP A as well as
>> IP B since the specification says the gratuitous arp should be
>> sent for all the IP address it owns. In this case all the four
>> hosts ARP cache will be updated with virtual MAC "00 00 5E XX XX 01".

>        The router on the left owns IP A, and the router on the
> right owns IP B.
>
 >       When the left router comes up, it will become master of
> virtual router 1, and will send a gratuitous ARP for IP A, with
> MAC address 00 00 5E XX XX 01. When the router on the right comes
> up, it will become master of virtual router 2, and will send a
> gratuitous ARP for IP B, with MAC address 00 00 5E XX XX 02.
>
>        So the MAC address used by H1 and H2 to reach IP A will
> be different from the MAC address used by H3 and H4 to reach IP B.

Thanks a lot for your reply. We have few thing to get clarified.

You have considered the case where gratuitous ARP is sent for IP A by 
virtual router VRID1. But in the "draft-ietf-vrrp-spec-04.txt" section 8.2 
paragraph 2 , it says gratuitous ARP should be sent for each IP Address on 
that interface (all IP Address it owns). So gratuitous ARP will be sent to 
both IP A as well as IP B and all the four hosts will be updated with the 
virtual address of VRID1 and Load sharing will not happen.

Regards
Rao & Basil

V.R.N. Rao & Anton Basil
Future Software Pvt., Ltd.,
481, Nandanam,
Madras - 600 035.

Voice : 91-44-4340323, 4330550 (Extn : 331)
Fax : 91-44-4344157, 4834551, 4834661
Email : [email-masked], [email-masked]

---

From: Peter Hunt <[email-masked]>
Date: Mon, 19 Jan 1998 11:26:05 -0800

Rao & Basil,

> Thanks a lot for your reply. We have few thing to get clarified.

I hope I can help clarify them.

> that interface (all IP Address it owns).

That is correct. Section 8.2 Paragraph 2 states:

    - When configuring an interface, VRRP routers should broadcast a
      gratuitous ARP request containing the virtual router MAC address
      for each IP address on that interface.

So, in the diagram you included in your initial mail message:

                       VRID=1       VRID=2
                      +-----+      +-----+
                      | MR1 |      | MR2 |
                      |  &  |      |  &  |
                      | BR2 |      | BR1 |
                      +-----+      +-----+
         IP A ---------->*            *<---------- IP B
                         |            |
                         |            |
                         |            |
       ------------------+------------+-----+--------+--------+--------+--
                                            ^        ^        ^        ^
                                            |        |        |        |
                                          (IP A)   (IP A)   (IP B)   (IP B)
                                            |        |        |        |
                                         +--+--+  +--+--+  +--+--+  +--+--+
                                         |  H1 |  |  H2 |  |  H3 |  |  H4 |
                                         +-----+  +-----+  +--+--+  +--+--+

      Legend:
               ---+---+---+--  =  802 network, Ethernet or FDDI
                            H  =  Host computer
                           MR  =  Master Router
                           BR  =  Backup Router
                            *  =  IP Address
                         (IP)  =  default router for hosts

	... the router on the left only has one IP address configured on
its LAN interface: IP A. Therefore, the router on the left will *only*
send a gratuitous ARP for IP A, and the MAC address in the ARP request
will be the virtual router MAC address for VRID 1 (ie. 00 00 5E XX XX 01).

> So gratuitous ARP will be sent to  both IP A as well as IP B and all
> the four hosts will be updated with the  virtual address of VRID1 and
> Load sharing will not happen.

	This is where we start to disagree :).

	The only case in which the router on the left will send a gratuitous
ARP request for IP B is if the router on the right fails. In that case, the
router on the left adopts all the virtual router information from the failed
router, including the failed router's VRID, in addition to its own.

	So, while it's true that in this situation, the router on the left
will have both IP A and IP B configured on its LAN interface, IP B will
still be associated with VRID 2. So when the router on the left sends out
the gratuitous ARP message for IP B, it will contain the virtual router
MAC address for VRID 2 (ie. 00 00 5E XX XX 02). Any ARP responses sent
for IP A will still contain the virtual router MAC address for VRID 1
(ie. 00 00 5E XX XX 01).

	I hope some of this helps. If I'm still not considering the
situation you're thinking of, please describe the situation in more detail.

	Thanks and regards,

	Peter